package jamvm;

public class VMGp2xStub {

	/** Fast Proportional Font **/
	
	/**
	 * Returns the rendered width of the text
	 * 
	 * @param text the text to measure
	 * @return the width in pixel
	 */
	public static  int sFont_TextWidth(String text)
  {
    System.out.println("VMGp2xStub: sFont_TextWidth("+text+")");
    return text.length();
  }
	
	/**
	 * Returns the current font height
	 * 
	 * @return the current font height
	 */
	public static  int sFont_TextHeight()
  {
    System.out.println("VMGp2xStub: sFont_TextHeight()");
    return 1;
  }

	
	/**
	 * Writes a text on the passed in Surface identifier, this identifier can be retrieved in this way:
	 * SDLSurface surface = gp2x.getFramebuffer();
	 * SDL_Surface swigSurface = surface.getSwigSurface();
     * int surfaceId = (int)SDL_Surface.getCPtr(swigSurface);
	 * 
	 * @param x X coordinate
	 * @param y Y coordinate
	 * @param text a string
	 * @param surface the identifier of the surface to write to 
	 */
	public static  void sFont_Write(int x, int y, String text, int surface)
  {
    System.out.println("VMGp2xStub: sFont_Write("+x+", "+y+", "+text+", "+surface+")");
  }


	/**
	 * Writes a text on the passed in Surface identifier, centered on the Surface X axis.
	 * The surface identifier can be retrieved in this way:
	 * SDLSurface surface = gp2x.getFramebuffer();
	 * SDL_Surface swigSurface = surface.getSwigSurface();
     * int surfaceId = (int)SDL_Surface.getCPtr(swigSurface);
	 * 
	 * @param y Y coordinate
	 * @param text a string
	 * @param surface the identifier of the surface to write to 
	 */
	public static  void sFont_WriteCenter(int y, String text, int surface)
  {
    System.out.println("VMGp2xStub: sFont_WriteCenter("+y+", "+text+", "+surface+")");
  }


	/**
	 * Scale the current font with the given factor and smooth.
	 * Zoom=100 is the base value, less than 100 reduces, more than 100 enlarges.
	 * The double multiplication value is calculated by dividing the integer value by 100, so it is
	 * possible to scale the font to 0.01 of the original size. 
	 * 
	 * @param zoomx integer X zoom factor.
	 * @param zoomy integer X zoom factor.
	 * @param smooth 0 or 1 value, if smooth=1 the scaled font is antialiased.
	 */
	public static  void sFont_ScaleFont(int zoomx, int zoomy, int smooth)
  {
    System.out.println("VMGp2xStub: sFont_ScaleFont("+zoomx+", "+zoomy+", "+smooth+")");
  }

	
	/**
	 * Reset the scaled font to the original size and form so it can be rescaled another time.
	 */
	public static  void sFont_ResetFont()
  {
    System.out.println("VMGp2xStub: sFont_ResetFont()");
  }


	
	/** Battery and GPIO Command control **/
	
	/** Battery codes **/

	public static final int BATTERY_ERROR		=	0;
	public static final int BATTERY_CRITICAL	=	1;
	public static final int BATTERY_LOW			=	2;
	public static final int BATTERY_MEDIUM		=	3;
	public static final int BATTERY_HIGH		=	4;
	public static final int BATTERY_FULL		=	5;
	public static final int BATTERY_AC			=	6;

	/**
	 * Retrieves the Battery status.
	 * 
	 * @return the current battery status
	 */
	public static  int getBatteryStatus()
  {
    System.out.println("VMGp2xStub: getBatteryStatus: return AC POWER");
    return BATTERY_AC;
  }



	/** GPIO Command codes **/

	public static final int BACK_LIGHT_OFF	=	0;
	public static final int BACK_LIGHT_ON	=	1;
	public static final int BATT_LED_ON		=	2;
	public static final int BATT_LED_OFF	=	3;

	public static final int FCLK_200		=	10;
	public static final int FCLK_166		=	11;
	public static final int FCLK_133		=	12;
	public static final int FCLK_100		=	13;
	public static final int FCLK_78			=	14;
	public static final int FCLK_64			=	15;
	
	public static final int FCLK_DEFAULT	=	16;
	
	/**
	 * Sends Control commands to the GPIO device
	 *
	 * @param command the command code
	 */
	public static  void gpioControl(int command)
  {
    System.out.println("VMGp2xStub: gpioControl: command "+command);
  }

	
	/**
	 * Tryes to change the CPU Clock to the specified MHz value
	 * 
	 * @param megahertz desired clock, can range from 50 to 300 MHz, if out of range it is rounded to the nearest limit
	 */
	public static  void cpuClockControl(int megahertz)
  {
    System.out.println("VMGp2xStub: cpuClockControl: set clock to "+megahertz);
  }

}
