package val.games.hello;

import java.io.File;

import com.synclast.Font;

import sdljava.video.SDLColor;
import sdljava.video.SDLSurface;
import val.gp2x.GP2x;


public class Hello
{
  private GP2x gp2x = null;
  
  public Font gameFontBig = null;
  private boolean finished = false;

  // ************************ Start *************************************
  public Hello(GP2x gp2x) throws Exception
  {
    // initialize the screen/joystick hardware devices
    this.gp2x = gp2x;

    // Root Path
    String ApplicationRootPath = System.getProperty("application.root.path");
    if (ApplicationRootPath == null)
      ApplicationRootPath = "." + File.separator;
    else
      ApplicationRootPath += File.separator;

    gameFontBig = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_LARGE);
  }

  
  /**
   * Redraws completely the screen
   */
  private void writeStringAt(Font font, String s, int x, int y, SDLColor color)
  {
    try
    {
      SDLSurface s1 = font.writeString(s, color);
      gp2x.drawImage(s1, x, y);
      s1.freeSurface();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  


  /*
   */
  public void mainGameLoop()
  {
    try
    {
      SDLColor color = new SDLColor(255, 255, 0);
      
      gp2x.clearScreen();
      writeStringAt(gameFontBig, "Hello World !!11!!", 20, 20, color);
      writeStringAt(gameFontBig, "Press any key to exit...", 20, 100, color);
      
      gp2x.repaint();

      while (!finished)
      {
        if ( gp2x.getJoyButtonChanges() )
          finished = true;
        Thread.sleep(200);
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    
  }

}
