package com.synclast;

import sdljava.SDLException;

import com.synclast.SynclastManager;


/**
 * Wraps the phisical Canvas
 */
public abstract class BaseCanvas
{
  public static final int UP = 1;
  public static final int DOWN = 6;
  public static final int LEFT = 2;
  public static final int RIGHT = 5;
  public static final int FIRE = 8;


  public int getGameAction(int keyCode)
  {
    // FIXME: fix me !! needed by toolkit
    return keyCode;
  }

  public boolean isShown()
  {
    // FIXME: fix me !! needed by toolkit
    return true;
  }

  public final int getWidth()
  {
    return 320;
  }

  public final int getHeight()
  {
    return 240;
  }

  public final boolean isDoubleBuffered()
  {
    return false;
  }
  
  private static Graphics myG = null;

  public final void repaint()
  {
    try
    {
      if (myG == null)
        myG = new Graphics( SynclastManager.getGP2x().getFramebuffer() );
      this.paint(myG);
      SynclastManager.getGP2x().getFramebuffer().flip();
    }
    catch (SDLException e)
    {
      e.printStackTrace();
    }
  }

  public final void repaint(int x, int y, int width, int height)
  {
    repaint();
  }

  public abstract void paint(Graphics g);

  public abstract void setCommandListener(CommandListener commandListener);
  
  public abstract void keyReleased(int keyCode);

  public abstract void keyRepeated(int keyCode);

  public abstract void keyPressed(int keyCode);

  public abstract void pointerPressed(int x, int y);

  public abstract void pointerDragged(int x, int y);

  public abstract void pointerReleased(int x, int y);

  public abstract void showNotify();

  public abstract void hideNotify();
  
}