package com.synclast;

import sdljava.SDLException;
import sdljava.image.SDLImage;
import sdljava.video.SDLSurface;
import sdljava.video.SDLVideo;

public class Image
{
  Graphics myGraphics = null;
  SDLSurface imageSurface = null;
  
  private Image()
  {
  }
  
  public static Image createImage(int width, int height)
  {
    Image i = new Image();
    try
    {
      i.imageSurface = SDLVideo.createRGBSurface(
          (long)SDLVideo.SDL_SWSURFACE,
          width,
          height,
          32, 0, 0, 0, 0);
      i.myGraphics = new Graphics(i.imageSurface);
    }
    catch (SDLException e)
    {
      e.printStackTrace();
    }

    System.out.println("Created image by size "+width+"x"+height+" : "+i);
    return i;
  }

  public static Image createImage(String rname)
  {
    Image i = new Image();
    try
    {
      i.imageSurface = SDLImage.load(rname);
      i.myGraphics = new Graphics(i.imageSurface);
    }
    catch (SDLException e)
    {
      e.printStackTrace();
    }

    System.out.println("Created image by file "+rname+" : "+i);
    return i;
  }

  public Graphics getGraphics()
  {
    return myGraphics;
  }

  public int getWidth()
  {
    return myGraphics.getWidth();
  }

  public int getHeight()
  {
    return myGraphics.getHeight();
  }

}
