/*
    $Id: Styled.java,v 1.1.1.1 2005/11/14 17:33:29 val Exp $

    This file is part of the Synclast UI API.

    The Synclast UI API is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    The Synclast UI API is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the Synclast UI API; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.synclast;

/**
 * Indicates an item that a StyleSheet can be applied to.
 */
public interface Styled {
    /**
     * Sets the indicated property (typically a defined constant)
     * to the value requested.  This should be a hint to the instance
     * that the default value for the property has changed.  If the
     * user has overridden the value manually, this value may
     * be ignored.
     */
    public void setDefault(int property, int value);
}
