package com.synclast.test;

import com.synclast.BaseCanvas;
import com.synclast.Command;
import com.synclast.Environment;
import com.synclast.Graphics;


import com.synclast.Event;
import com.synclast.ui.Button;
import com.synclast.ui.Input;
import com.synclast.ui.Label;
import com.synclast.ui.Widget;
import com.synclast.ui.containers.Container;
import com.synclast.ui.extra.MultilineLabel;
import com.synclast.ui.extra.SuperInput;

/**
 * Base class for Synclast demo MIDlets. Subclasses need only override the createCanvas() method.
 */
public class ScreenChat extends BaseScreen
{
  public static final String myName = "screenchat";

  private Label labelName = null;
  private MultilineLabel labelChatWindow = null;
  private SuperInput chatMessage = null;
  private Button sendButton = null;
  private Button closeButton = null;
  private String conversation = "";
  
  public String getMyName()
  {
    return ScreenChat.myName;
  }
  
  private void placeBlock(Container container, Widget widget, int x, int y)
  {
    widget.setPosition(x, y, Graphics.LEFT | Graphics.TOP);
    container.remove(widget);
    container.add(widget).validate();
  }
  
  public BaseCanvas createScreen(Environment midlet, int width, int height)
  {
    Container container = BaseScreen.getDefaultContainer(this);

      sendButton = new Button("Send");
      closeButton = new Button(TestRuntimeData.getInstance().getImage("x.gif"));
      closeButton.set(Button.IMAGE_MODE, Button.CENTERED);
      closeButton.set(Button.BORDER_WIDTH, 0);
      closeButton.set(Button.INSET_WIDTH, 1);
      
      // XXXX are to reserve pixel space
      labelName = new Label("XXXXXXXXXXXXX");
      labelName.set(Label.FOREGROUND_COLOR, (TestRuntimeData.getInstance().getVOAdditionalstyle())[1]);
      
      labelChatWindow = new MultilineLabel(
          "XXXXXXXXXXXXXXXX\n"+
          "XXXXXXXXXXXXXXXX\n"+
          "XXXXXXXXXXXXXXXX\n"+
          "XXXXXXXXXXXXXXXX\n"+
          "");
      labelChatWindow.set(Label.BORDER_WIDTH, 1);
      labelChatWindow.set(Label.BORDER_COLOR, (TestRuntimeData.getInstance().getVOAdditionalstyle())[6] );

      chatMessage = new SuperInput();
      chatMessage.set(Input.MAX_SIZE, 1024);
      chatMessage.set(Input.WIDTH, 100);
      chatMessage.setAdapters("Tap-Upper,Tap-Lower,Numeric");

      placeBlock(container, closeButton, 10, 60);
      placeBlock(container, labelName, 25, 60);
      
      placeBlock(container, labelChatWindow, 10, 2+closeButton.getBaseline());
      placeBlock(container, chatMessage, 10, 2+labelChatWindow.getBaseline());
      placeBlock(container, sendButton, 12+chatMessage.getWidth(), 2+labelChatWindow.getBaseline());

      BaseCanvas cnv = BaseScreen.finalizeCanvas(this, container);
      
      labelName.setText("DeMo");
      conversation = "";
      labelChatWindow.setText("");
      chatMessage.setString("Mao Mao");
      
      return cnv;
  }

  
  public EventResult handleEvent(Command command)
  {
    EventResult ver = super.handleEvent(command);
    if (ver.handled)
      return ver;

    if (Event.getSource(command) == sendButton)
    {
      this.showMessage(myName, "Send");
      conversation += "*1*demo says:\n"+chatMessage.getString()+"\n";
      labelChatWindow.setText(conversation);
      labelChatWindow.repaint();
      chatMessage.setString("");
      ver.handled = true;
    }

    if (Event.getSource(command) == closeButton)
    {
      ver.handled = true;
      ver.nextStep = EventResult.CHANGE_SCREEN;
      ver.nextStepAdditional = "screenbuddylist";
      
      {
        this.getNetworkActivityImage().setVisible(true);
        BaseScreen.getMyCanvas(this.getMyName()).repaint();
        this.getNetworkActivityImage().showNotify();

        /*
        try
        {
          Thread.sleep(1000);
        }
        catch (InterruptedException e)
        {
        }
        
        this.getNetworkActivityImage().setVisible(false);
        m.getCurrentCanvas().repaint();
        this.getNetworkActivityImage().hideNotify();
        */
      }

    }

    return ver;
  }

}