package com.synclast.test;

import java.util.Hashtable;


import com.synclast.Graphics;
import com.synclast.Image;
import com.synclast.StyleSheet;
import com.synclast.ui.Button;
import com.synclast.ui.Checkbox;
import com.synclast.ui.Color;
import com.synclast.ui.ColoredWidget;
import com.synclast.ui.Input;
import com.synclast.ui.Label;
import com.synclast.ui.Menu;
import com.synclast.ui.extra.ImageMenu;


public class TestRuntimeData
{
  private static TestRuntimeData instance = null;
  
  public static TestRuntimeData getInstance()
  {
    if (instance == null)
      instance = new TestRuntimeData();
    return instance;
  }
  
  private TestRuntimeData()
  {
  }
  
  /*****************************************************************
   * ACTIVE SKIN 
   *****************************************************************/

  private Hashtable activeskin = new Hashtable();
  
  // Global Stylesheet
  public StyleSheet vaVOstyle = new StyleSheet()
    .setStyle(Input._class, Input.BACKGROUND_COLOR, Color.WHITE)
    .setStyle(Input._class, Input.BORDER_COLOR, Color.DEMI_GREY)
    .setStyle(Input._class, Input.FOREGROUND_COLOR, Color.DARK_GRAY)
    .setStyle(Checkbox._class, Checkbox.BACKGROUND_COLOR, Color.WHITE)
    .setStyle(Label._class, Label.FOREGROUND_COLOR, Color.UBER_GREY)
    .setStyle(Button._class, Button.BACKGROUND_COLOR, Color.WHITE)
    .setStyle(Button._class, Button.FOREGROUND_COLOR, Color.UBER_GREY)
    .setStyle(Button._class, Button.BORDER_COLOR, Color.DEMI_GREY)
    .setStyle(ImageMenu._class, Menu.SELECTED_FOREGROUND_COLOR, Color.WHITE)
    .setStyle(ImageMenu._class, Menu.SELECTED_BACKGROUND_COLOR, Color.UBER_GREY)
    .setStyle(ImageMenu._class, Menu.FOREGROUND_COLOR, Color.UBER_GREY)
    .setStyle(ImageMenu._class, Menu.BACKGROUND_COLOR, Color.DEMI_GREY)
    .setStyle(ImageMenu._class, Menu.FOCUSED_BORDER_COLOR, Color.UBER_GREY)
    .setStyle(ImageMenu._class, Menu.UNFOCUSED_BORDER_COLOR, Color.DEMI_GREY)
    .setStyle(ImageMenu._class, Menu.ITEM_ALIGN, Graphics.LEFT)
    .setStyle(Button._class, Button.IMAGE_MODE, ColoredWidget.TILED)
  ;


  // indexes are:
  // 0: color, "please wait..." in loginExe
  // 1: color, label border in chat
  // 2: color, buddy 1 in chat
  // 3: color, buddy 2 in chat
  // 4: color, buddy 3 in chat
  // 5: color, buddy 4 in chat
  // 6: color, buddy name in chat
  public int vaAdditionalScheme[] = { Color.UBER_GREY,
                                      Color.UBER_GREY,
                                      Color.DEMI_GREY,
                                      Color.UBER_GREY,
                                      Color.RED,
                                      Color.ORANGE,
                                      Color.WHITE }; 
  
  public StyleSheet getVOstyle()
  {
    return vaVOstyle;
  }
  
  public int[] getVOAdditionalstyle()
  {
    return vaAdditionalScheme;
  }
  
  /**
   * Retrieve an image from a resource, manage the active skin
   * @param resource
   * @return an Image or null
   */
  public Image getImage(String resource)
  {
    String rname = "images/"+resource;
    
    try
    {
      if (activeskin.get(rname) != null)
        return (Image)activeskin.get(rname);
      
      Image i = Image.createImage(rname);
      activeskin.put(rname, i);
      return i;
    }
    catch (Exception e)
    {
      return null;
    }
  }

}
