package com.synclast.test;

import java.util.*;


/**
 * Various utilities and the ACE response parser.
 */

public class TestUtils
{

  /**
   * replace a string inside another string.
   */
  public static String stringReplaceAll(String orig, String find, String repl) {
    String res = orig;
    int i = -1;
    
      while ((i = res.indexOf(find)) >= 0) {
        res = res.substring(0, i) + repl + res.substring(i+find.length(), res.length());
      }

    return res;
  }

  /**
   * replace a string inside another string, only the first one.
   */
  public static String stringReplaceOne(String orig, String find, String repl) {
    String res = orig;
    int i = -1;
    
      if ((i = res.indexOf(find)) >= 0) {
        res = res.substring(0, i) + repl + res.substring(i+find.length(), res.length());
      }

    return res;
  }

  public static void DEBUG(String s)
  {
    // stdout
    System.out.println(s);

    // http out
    // fastReadContents("http://10.129.160.34/x?a="+urlEncode(s));
  }

  public static void INFO(String s)
  {
    // stdout
    System.out.println(s);
    
    // http out
    // fastReadContents("http://10.129.160.34/x?a="+urlEncode(s));
  }

  public static void StopDEBUG()
  {
  }


  /**
   * takes a whole response text from the server and split it
   * as a series of property-value
   * 
   * @param txt
   * @return
   */
  public static Hashtable parseResponse(String txt) {
    Hashtable tab = new Hashtable();
    int i = -1;
    
    Vector table = splitString(txt, "\n");
    for (i = 0; i<table.size(); i++)
    {
      Vector prop = splitString((String)table.elementAt(i), "=");
      
      String key = null;
      String value = null;

      if (prop.size() >= 1)
        key = (String)prop.elementAt(0);
      else
        key = "";
      if (prop.size() >= 2)
        value = (String)prop.elementAt(1);
      else
        value = "";
      
      tab.put(key, TestUtils.urlDecode(value));
    }

    return tab;
  }
  

  
  public static Vector splitString(String txt, String sep)
  {
		Vector res = new Vector();
		int i = -1;
		
			while ((i = txt.indexOf(sep)) >= 0) {
				res.addElement(txt.substring(0, i).trim());
				txt = txt.substring(i+sep.length(), txt.length());
			}
      
      if (txt.length() > 0)
        res.addElement(txt.trim());

		return res;
	}
	
	public static String urlDecode(String enc) {
		StringBuffer res = new StringBuffer();
		int jump = 0;
		
			for (int i=0; i<enc.length(); i++) {
				int c = enc.charAt(i);
		
				if (jump > 0) { jump--; continue; }
						
				if (c == '+') res.append(' ');
				else if (c == '%') {
					StringBuffer sb = new StringBuffer();
					sb.append(enc.charAt(i+1));
					sb.append(enc.charAt(i+2));
					c = Integer.parseInt(sb.toString(), 16);
					res.append((char)c);
					jump = 2;
				}
				else res.append((char)c);
			}
			
		return res.toString();
	}

	public static char HexChar( int offset ) {
	  String hexchars = "0123456789ABCDEF";
	  return hexchars.charAt( offset );
	}

	public static String urlEncode( String input ) {
	  StringBuffer output = new StringBuffer();
	  for( int i = 0 ; i < input.length() ; i++ ) {
		char c = input.charAt( i );
		if( c == ' ' )
			output.append( '+' );
		else if ( ( c >= 'A' && c <= 'Z' ) ||
				( c >= 'a' && c <= 'z' ) ||
				( c >= '0' && c <= '9' ) )
			output.append( c );
		else {
		  output.append( '%' );
		  output.append( HexChar( (((int)c & 0xF0) >> 4 ) ) );
		  output.append( HexChar( (int)c & 0x0F ) );
		}
	  }
	  return output.toString();
	}

}
