/*
    $Id: Color.java,v 1.4 2005/11/28 13:14:35 val Exp $

    This file is part of the Synclast UI API.

    The Synclast UI API is free software; you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    The Synclast UI API is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the Synclast UI API; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.synclast.ui;

/**
 * Defines useful enumerated constants for colors.
 * Note that many J2ME displays are limited in the number
 * of colors, and some have more bits available for one
 * of the primaries than another.
 */
public final class Color {
    // Not instantiable
    private Color() { }

    // Monochrome
    public static final int BLACK = 0x00000000;
    public static final int WHITE = 0x00ffffff;

    // Greys
    public static final int DARK_GRAY =   0x00666666;
    public static final int MEDIUM_GRAY = 0x00999999;
    public static final int LIGHT_GRAY =  0x00cccccc;

    // Primary
    public static final int RED =   0x00ff0000;
    public static final int GREEN = 0x0000ff00;
    public static final int BLUE =  0x000000ff;

    // Secondary
    public static final int YELLOW =  0x00ffff00;
    public static final int CYAN =    0x0000ffff;
    public static final int MAGENTA = 0x00ff00ff;

    public static final int DEMI_BLUE = 0x00CCEFFD; // semichiaro
    public static final int UBER_BLUE = 0x0009B5FF; // semiscuro

    public static final int DEMI_RED = 0x00FDEFCC; // semichiaro
    public static final int UBER_RED = 0x00FFB509; // semiscuro

    public static final int DEMI_GREY = 0x00C0C0C0; // semichiaro
    public static final int UBER_GREY = 0x00808080; // semiscuro

    public static final int ORANGE = 0x00FFC832;
    
    // Not really a color, but...
    public static final int TRANSPARENT = -1;
}
