package com.synclast.ui.extra;


import com.synclast.Graphics;
import com.synclast.ui.Input;

/**
 * Represents a basic text input widget.  An Input widget uses one or more
 * InputAdapter instances in order to translate user input into
 * characters.  If no adapter is otherwise specified, an instance
 * of the base class InputAdapter is used; this provides a straight
 * mapping of keycodes to characters.  
 * 
 * Applications that want to do text entry with a numeric keypad should
 * use the TapInputAdapter; two named instances are available by default,
 * and others can be configured via JAD properties.  See the TapInputAdapter
 * class for details.
 */
public class SuperInput extends Input
{
    // Workaround for MIDP 1.0 .class access
    public static Class _class = new SuperInput().getClass();

    public SuperInput() {
      super();
    } 

    public SuperInput(String adapterList) {
      super(adapterList);
    }


    public void paint(Graphics graphics) {
        super.paintNoText(graphics);

        // Draw the text
        if (text.length() > 0) {
            char[] temp = text.toString().toCharArray();
            if (properties[MASK_CHAR] != 0) {
                for (int i = 0; i < temp.length; i++) {
                    temp[i] = (char) properties[MASK_CHAR];
                }
            }

            graphics.setFont(font);
            graphics.drawChars(temp, 0, temp.length, 0, 0, 
                               Graphics.TOP | Graphics.LEFT);
        }

        // Draw the cursor, if it's on
        if (on) {
            graphics.fillRect(pixelOffset, 1, 
                              2, font.getBaselinePosition() + 1);
        }
    }
}
