package val.games.paperotte;

import sdljava.SDLException;


class Mirino
{
  int xCenter, yCenter;
  Sprite sprite;
  Sound fireSound;
  
  // Constructor
  public Mirino(Sprite sprite, Sound sound)
  {
    this.sprite = sprite;
    this.fireSound = sound;
  }

  public void setInitialPosition(int x, int y)
  {
    sprite.position.x = x;
    sprite.position.y = y;
    
    xCenter = x+sprite.halfFrameWidth;
    yCenter = y+sprite.halfFrameHeight;
  }
  
  public void moveTo(int xoff, int yoff)
  {
    sprite.position.x += xoff;
    sprite.position.y += yoff;
    
    sprite.keepInsideScreen();

    xCenter = sprite.position.x+sprite.halfFrameWidth;
    yCenter = sprite.position.y+sprite.halfFrameHeight;
  }
  
  public void redraw()
  {
    try
    {
      sprite.redraw();
    }
    catch (SDLException e)
    {
    }
  }

}
