package val.games.paperotte;

import sdljava.SDLException;
import val.games.paperotte.functions.Function;


class Paperotta
{
  boolean isMorta;
  Sprite sprite;
  Function function;

  // Constructor
  public Paperotta(Function function, Sprite sprite)
  {
    this.isMorta = false;
    this.sprite = sprite;
    this.function = function;
  }

  public void setInitialPosition(int x, int y)
  {
    sprite.position.x = x;
    sprite.position.y = y;
  }
  
  public boolean isHit(int x, int y)
  {
    if (this.isMorta)
      return false;
    
    if (sprite.position.x <= x && sprite.position.y <= y)
    {
      if (sprite.position.x + sprite.frameWidth > x && sprite.position.y + sprite.frameHeight > y)
        return true;
    }
    
    return false;
  }
  
  public boolean isOutOfGame()
  {
    return ! function.willAppearOnScreen(sprite.position.x, sprite.position.y, 0);
  }

  public void move(int speed)
  {
    // calculate the next y based on current x + speed
    int x = sprite.position.x;
    int y = sprite.position.y;
    sprite.position.x = function.calculateNextX(x, y, speed);
    sprite.position.y = function.calculateNextY(x, y, speed);
  }

  public void redraw()
  {
    try
    {
      sprite.redraw();
    }
    catch (SDLException e)
    {
    }
  }

}
